<template>
  <div class="marvel-project-pagination">
    <button class="marvel-project-pagination__pre"
      v-if="this.currentPage > 1"
      @click="this.$store.commit('setPrePageNumber', this.currentPage)">
      &lt;-
    </button>

    <button
      class="marvel-project-pagination__number"
      v-for="page in this.totalPagination"
      v-bind:key="page"
      :class="{
        current: this.currentPage === page, 
        last: (page === this.totalPagination && Math.abs(page - this.currentPage) > 3), 
        first: (page === 1 && Math.abs(page - this.currentPage) > 3), 
        hidden: (page !== 1 && page !== this.totalPagination && Math.abs(page - this.currentPage) > 3)
      }"
      @click="setPage(page)">
        {{page}}
    </button>

    <button class="marvel-project-pagination__next" 
      v-if="this.currentPage < this.totalPagination"
      @click="this.$store.commit('setNextPageNumber', this.currentPage)">
      -&gt;
    </button>
  </div>
</template>

<script>

export default {
  name: 'PaginationMarvel',
  data() {
    return {}
  },
  computed: {
    totalPerso() {
      return this.$store.getters.getTotalPerso;
    },
    totalPagination() {
      return this.$store.getters.getTotalPage
    },
    currentPage() {
      return this.$store.getters.getPageNumber
    }
  },

  watch:{
    currentPage() {
      this.$store.dispatch('fetchApi');
    }
  },
  methods: {
    setPage(page) {
      this.$store.commit('setPageNumber', page)
    }
  }
}

</script>

<style scoped lang="scss">
.marvel-project-pagination {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 5rem;
  margin: 2rem 5rem;
  border-radius: 0.6rem;
  background: $color-white;
  box-shadow: 0 0.8rem 2rem rgba(90, 97, 129, 0.05);

  &__number {
    &.hidden {
      display: none;
    }
    &.first::after {
      content: '...';
    }
    &.last::before {
      content: '...';
    }
    &.current {
      color: white;
      background: $color-secondary;
      font-weight: 600;
      border: 1px solid $color-secondary;
    }
    &__next, &__pre {
      color: $color-secondary;
    }
  }

  &__number, &__next, &__pre {
    width: 2.6rem;
    height: 2.6rem;
    border-radius: 0.4rem;
    box-shadow: none;
    border: none;
    display: flex;
    justify-content: center;
    align-items: center;
    margin: 0.2rem;
    font-size: 1.4rem;
    cursor: pointer;
  }
}
</style>
